public class BookReadersFirst extends Book{
	private Semaphore readersEntry = new Semaphore(1,"readersEntry"),
					  writersEntry = new Semaphore(1,"writersEntry");
	private int readcount = 0;
	
	@Override
	public String read(){
		
		// Entry Section
		readersEntry.acquire();
		if(readcount==0)
			writersEntry.acquire();
		readcount++;
		readersEntry.release();
		
		// Critical Section
		try {
			System.out.println(Thread.currentThread().getName()+" read:"+content);
			Thread.sleep(gen.nextInt(200));   // reading
		} catch(InterruptedException e) { };	
		
		// Exit Section
		readersEntry.acquire();
		readcount--;
		String c = content;
		if(readcount==0)
			writersEntry.release();  // kustutab valguse
		readersEntry.release();
		return c;
		
	}
	
	@Override
	public void write(){
		// Entry Section
		writersEntry.acquire();
		
		// Critical Section
		String s = alphabet.substring(next,next+1);
		next = (next+1) % alphabet.length();
		content += s;
		try {
			Thread.sleep(gen.nextInt(100));
		} catch(InterruptedException e) { };
		System.out.println(Thread.currentThread().getName()+ " add "+s);
		
		// Exit Section
		writersEntry.release();
	}
}
